package gameObjects {

    import mx.core.*;
    import mx.controls.*;
    import flash.events.*;
    import flash.display.Sprite;
    import flash.display.Loader;
    import flash.net.URLRequest;
    import flash.geom.Point;
    import flash.utils.Timer;
    
    public class Avatar extends Image {
        
	      private static const IMG_FOLDER:String ='tilegame_assets/images/';
  	    private static const IMG_AVATAR:String = 'avatar.gif'
  	    private static const IMG_AVATAR_L:String = 'avatar.gif'
  	    private static const IMG_AVATAR_U:String = 'avatar.gif'
  	    private static const IMG_AVATAR_R:String = 'avatar.gif'
  	    private static const IMG_AVATAR_D:String = 'avatar.gif'

  	    private static const DIR_L:uint = 0;
  	    private static const DIR_U:uint = 1;
  	    private static const DIR_R:uint = 2;
  	    private static const DIR_D:uint = 3;
  	    
  	    public var seekLoc:Point;
  	    public var oldLoc:Point;
  	    public var movedFlag:Boolean = false;
        public var tileArray:Array;

  	    private var _direction:uint;
	      private var _imgFolder:String =IMG_FOLDER + 'avatar/';
	      private var _tileCols:uint;
	      private var _tileRows:uint;
        private var _timer:Timer;
	      

        public function Avatar() {
            this._direction = DIR_U
            this.source = getSource()
          }
        
        public function setDirection(value:uint):void {
          this._direction = value;
        }
        
        public function startLevel():void {
          var curTile:MapTile;
          // Position idAvatarU
          curTile = tileArray[seekLoc.x][seekLoc.y]
          this.x = curTile.x
          this.y = curTile.y

          _tileCols = tileArray.length
          _tileRows = tileArray[0].length
          
          // Position Target for next move
          oldLoc = new Point(seekLoc.x, seekLoc.y);

        }
        public function startWalking():void {
          _timer = new Timer(50)
          _timer.addEventListener("timer", walk);
          _timer.start();
        }
        
        private function walk(e:TimerEvent):void {
          var curLoc:Point;
          var curDir:uint;
          var curTile:MapTile;

          curLoc = new Point(oldLoc.x, oldLoc.y);
          
          movedFlag = false;
          
          /* -----------------
              x location
          ------------------- */
          if (seekLoc.x > curLoc.x) {
            curLoc.x++;
            curDir = DIR_R;
            movedFlag = true;
          } else if (seekLoc.x < curLoc.x) {
            curLoc.x--;
            curDir = DIR_L;
            movedFlag = true;
          }
          // Stay in bounds
          if (curLoc.x < 0) {
            curLoc.x = 0
          } else if (curLoc.x >= _tileCols) {
            curLoc.x = (_tileCols - 1)
          }
          // Check for collision
          curTile = tileArray[curLoc.x][curLoc.y] as MapTile
          if (curTile.walkable != true) {
            curLoc.x = oldLoc.x
          }

          /* -----------------
              y location
          ------------------- */
          if (seekLoc.y > curLoc.y) {
            curLoc.y++;
            curDir = DIR_D;
            movedFlag = true;
          } else if (seekLoc.y < curLoc.y) {
            curLoc.y--;
            curDir = DIR_U;
            movedFlag = true;
          }
          // Stay in bounds
          if (curLoc.y < 0) {
            curLoc.y = 0
          } else if (curLoc.y >= _tileRows) {
            curLoc.y = (_tileRows - 1)
          }
          // Check for collision
          curTile = tileArray[curLoc.x][curLoc.y] as MapTile
          if (curTile.walkable != true) {
            curLoc.y = oldLoc.y
          }
          
          // --------------  
          curTile = tileArray[curLoc.x][curLoc.y] as MapTile
          this.x = curTile.x
          this.y = curTile.y
          // --------------  
          if ((oldLoc.x != curLoc.x) || (oldLoc.y != curLoc.y)) {
            if (curTile.answer != ""){
              dispatchEvent(new ScoreEvent(curTile,ScoreEvent.UPDATE));
            }
            oldLoc = new Point(curLoc.x, curLoc.y);
          } else {
            _timer.stop()
          }
          

        }
        
        public function getSource():String {
          var imgSource:String = "";
          switch (this._direction) {
              case DIR_L:
                imgSource = IMG_AVATAR_L;
                break;
              case DIR_U:
                imgSource = IMG_AVATAR_U;
                break;
              case DIR_R:
                imgSource = IMG_AVATAR_R;
                break;
              case DIR_D:
                imgSource = IMG_AVATAR_D;
                break;
              default:
                // default
                imgSource = IMG_AVATAR_U;
          }
          return (_imgFolder + imgSource)
        }
        
        // should be rewritten as an event dispatcher. 
        private function showWarning(msg:String, mode:uint):void {
          if(mode == 1) {
            mx.controls.Alert.show(msg);
          } else {
            mx.controls.Alert.show(msg);
            // warningBox.text = msg;
          }
        }
    }
}
