package gameObjects {

    import mx.containers.*;    
    import mx.core.*;
    import mx.controls.*;
    import flash.events.*;
    import flash.display.Sprite;
    import flash.display.Loader;
    import flash.net.URLRequest;
    import flash.geom.Point;
    
    public class MapTile extends Canvas {
        
        // constants
  	    public static const IMG_FOLDER:String ='tilegame_assets/images/';

        // Alert Messages
        private const MSG_TILECODE:String = "Incorrect tile code";
        
        private const OBSTACLE_H:uint = 10;
        private const OBSTACLE_V:uint = 11;
        private const OBSTACLE_C:uint = 12;
        
        private const BLANK_DOPICK:uint = 20;
        private const BLANK_NOPICK:uint = 21;

        // ---------------- ---------------- ----------------
        public var tileId:uint; 
        public var tileType:String; 
        public var tileImg:String; 
        public var pickable:Boolean = false; 
        public var walkable:Boolean = false; 
        public var answer:String = "";
        public var xyLoc:Point;
        public var xPos:uint;
        public var tileBg:Image;
        public var tileTxt:Label;

        private var imgFolder:String = IMG_FOLDER + "tiles/"
        private var textLabel:Label;

        public function MapTile(tileCode:String, xy:Point) {
            if(tileCode.length > 1) {
                showWarning(MSG_TILECODE + ": "+tileCode , 0)
            }

            this.xyLoc = xy;
            pickable = false;
            walkable = false;
            // setStyle("borderStyle", "Solid")
            // setStyle("borderThickness", "1")
            

            switch (tileCode) {
                case "|":
                    tileId = OBSTACLE_V;
                    tileType = "obstacle";
                    tileImg = "obstaclev.gif";
                    break;
                case "-":
                    tileId = OBSTACLE_H;
                    tileType = "obstacle";
                    tileImg = "obstacleh.gif";
                    break;
                case "#":
                    tileId = OBSTACLE_C;
                    tileType = "obstacle";
                    tileImg = "roomplant2.gif";
                    break;
                case "*":
                    tileId = BLANK_NOPICK;
                    tileType = "blank";
                    tileImg = "blank.gif";
                    walkable = true;
                    break;
                case " ":
                    tileId = BLANK_DOPICK;
                    tileType = "blank";
                    tileImg = "blank.gif";
                    pickable = true;
                    walkable = true;
                    break;
                default:
                    // default
                    tileId = BLANK_DOPICK;
                    tileType = "blank";
                    tileImg = "blank.gif";
                    pickable = true;
                    walkable = true;
            }

            tileBg = new Image()
            tileBg.source = imgFolder + tileImg;
            /*
            tileTxt = new Label()
            tileTxt.text = String(walkable)  + " " + String(xyLoc.x) + "," + String(xyLoc.y);
            tileTxt.x = 30
            tileTxt.y = 40
            addChild(tileTxt);
            */
            addChild(tileBg);
          }
        
        public function getSource():String {
            return this.tileImg;
        }
        
        public function makePick(tag:String, cat:String):void {
          textLabel = new Label();
          textLabel.text = tag
          textLabel.y = 30;
          textLabel.width = 70;
          textLabel.setStyle("textAlign", "center")
          addChild(textLabel);

          /*  
          var button:Button = new Button();
          button.label = tag
          button.x = Math.floor((this.width - button.width) / 2)
          addChild(button);
          */

          setStyle("backgroundColor","0xFCFCA1")
          answer = cat
        }
        
        public function removePick():void {
          removeChild(textLabel)
          setStyle("backgroundColor","0xFFFFFF")
          answer = "";
        }
        // should be rewritten as an event dispatcher. 
        private function showWarning(msg:String, mode:uint):void {
          if(mode == 1) {
            mx.controls.Alert.show(msg);
          } else {
            mx.controls.Alert.show(msg);
            // warningBox.text = msg;
          }
        }
    }
}
